#!BPY

""" Registration info for Blender menus: <- these words are ignored
Name: 'ColorDialog'
Blender: 243
Group: 'Materials'
Tip: 'ColorDialog'
"""

__author__ = "Keines"
__version__ = "ver 2007.08.26(Sun) 00:00"

__bpydoc__ = """\
Note:
 Blender 2.43 + Python 2.4
 Blender 2.44 + Python 2.5

 It should run on any Python and Tkinter supported platform.
"""

import Blender
from Blender import Window,Draw,BGL,Scene,Object,Material

from Tkinter import *
import tkColorChooser

# + User  Config
BaseMaterial='Material'

# + Title
Title		= 'ColorDialog'
by              = ' by '
VerWidth	= Draw.GetStringWidth(__version__)

# + BaseValue
SpcWidth	= 20
BtnHeight	= 20
BtnWidth	= 20

Label	= ['>','@','Exit']
Label_Dialog	= 0
Label_Clip	= 1
Label_Exit	= 2

StringBtn=Draw.Create('')
StringBtn.val=BaseMaterial

BtnWidthString=180
BtnWidthExit=Draw.GetStringWidth(Label[Label_Exit])+SpcWidth
ExitPos=BtnWidthString-BtnWidthExit+BtnWidth*2+4
VerPos =BtnWidthString-VerWidth-BtnWidthExit+BtnWidth*2-4

Event_None	= 0
Event_Dialog	= 1
Event_Clip	= 2
Event_Exit	= 3

class ColorDialog(Frame):

  def __init__(self, master=None):
    Frame.__init__(self, master)
    self.master.withdraw()
    try:
      self.mat=Material.Get(StringBtn.val)
    except:
      self.mat=Material.New(StringBtn.val)
    colorTuple = tkColorChooser.askcolor(initialcolor=(self.mat.R*255,self.mat.G*255,self.mat.B*255))
    if colorTuple[0]:
      self.mat.rgbCol = [k/255.0 for k in colorTuple[0]]
      Window.Redraw(Window.Types["VIEW3D"])
      Window.Redraw(Window.Types["BUTS"])
    self.master.destroy()

def DrawGui():
    global StringBtn
    # --- Init Screen ---
    BGL.glClearColor(0.6, 0.6, 0.6, 0.0)
    BGL.glClear(Blender.BGL.GL_COLOR_BUFFER_BIT)
    BGL.glColor3f(0.1, 0.1, 0.15) # Text Color
    # --- Get Screen Size ---
    size=Blender.BGL.Buffer(Blender.BGL.GL_FLOAT, 4)
    Blender.BGL.glGetFloatv(Blender.BGL.GL_SCISSOR_BOX, size)
    size=[int(i) for i in size.list]  # FLOAT -> INT
    # Base Position
    x=20
    y=size[3]-BtnHeight
    # + Title
    z=y-5
    BGL.glRasterPos2f(x, y)
    Draw.Text(Title+by+__author__)
    # + Button
    y-=BtnHeight+16
    #   - ColorDialog
    Draw.Button (Label[Label_Dialog],Event_Dialog,x,y,BtnWidth,BtnHeight,"")
    StringBtn=Draw.String('Mat:',Event_None,x+BtnWidth+2,y,BtnWidthString,BtnHeight,StringBtn.val,255)
    Draw.Button (Label[Label_Clip],Event_Clip,x+BtnWidth+BtnWidthString+4,y,SpcWidth,BtnHeight,"")
    # + Version
    y-=BtnHeight+16
    BGL.glRasterPos2f(x+VerPos, y)
    Draw.Text(__version__)
    #   - Exit
    y-=2
    Draw.Button (Label[Label_Exit],Event_Exit,x+ExitPos,y,BtnWidthExit,BtnHeight,"")

def MatClip():
    global StringBtn
    ob=Blender.Scene.GetCurrent().objects.active
    if ob!=None:
      try:
        me=ob.getData()
        if me!=None:
          mats=me.materials[:]
          if (mats):
            mats=[m.name for m in mats]
            work=''
            for i,s in enumerate(mats):
	      work+='| %s %%x%d'%(s,i)
            i=Draw.PupMenu(work)
            if i!=-1:
              StringBtn.val = mats[i]
            Draw.Register(DrawGui, KeyEvent, ButtonEvent)
      except:
        None

def ButtonEvent(evt):
    if (evt==Event_Dialog)			:
      cd = ColorDialog()
      cd.mainloop()
    elif (evt==Event_Clip)			: MatClip()
    elif (evt==Event_Exit)			: Draw.Exit()

def KeyEvent(evt, val):
    # val: 1=KeyDown 0=KeyUp
    if (not val) :
        return
    elif evt in [Draw.ESCKEY, Draw.QKEY]:
        Draw.Exit()

Draw.Register(DrawGui, KeyEvent, ButtonEvent)
